(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms'), require('rxjs'), require('rxjs/operators'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('@ngneat/forms-manager', ['exports', '@angular/core', '@angular/forms', 'rxjs', 'rxjs/operators', '@angular/common'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.ngneat = global.ngneat || {}, global.ngneat["forms-manager"] = {}), global.ng.core, global.ng.forms, global.rxjs, global.rxjs.operators, global.ng.common));
})(this, (function (exports, i0, forms, rxjs, operators, common) { 'use strict';

    function _interopNamespace(e) {
        if (e && e.__esModule) return e;
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () { return e[k]; }
                    });
                }
            });
        }
        n["default"] = e;
        return Object.freeze(n);
    }

    var i0__namespace = /*#__PURE__*/_interopNamespace(i0);

    /******************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __esDecorate(ctor, descriptorIn, decorators, contextIn, initializers, extraInitializers) {
        function accept(f) { if (f !== void 0 && typeof f !== "function")
            throw new TypeError("Function expected"); return f; }
        var kind = contextIn.kind, key = kind === "getter" ? "get" : kind === "setter" ? "set" : "value";
        var target = !descriptorIn && ctor ? contextIn["static"] ? ctor : ctor.prototype : null;
        var descriptor = descriptorIn || (target ? Object.getOwnPropertyDescriptor(target, contextIn.name) : {});
        var _, done = false;
        for (var i = decorators.length - 1; i >= 0; i--) {
            var context = {};
            for (var p in contextIn)
                context[p] = p === "access" ? {} : contextIn[p];
            for (var p in contextIn.access)
                context.access[p] = contextIn.access[p];
            context.addInitializer = function (f) { if (done)
                throw new TypeError("Cannot add initializers after decoration has completed"); extraInitializers.push(accept(f || null)); };
            var result = (0, decorators[i])(kind === "accessor" ? { get: descriptor.get, set: descriptor.set } : descriptor[key], context);
            if (kind === "accessor") {
                if (result === void 0)
                    continue;
                if (result === null || typeof result !== "object")
                    throw new TypeError("Object expected");
                if (_ = accept(result.get))
                    descriptor.get = _;
                if (_ = accept(result.set))
                    descriptor.set = _;
                if (_ = accept(result.init))
                    initializers.push(_);
            }
            else if (_ = accept(result)) {
                if (kind === "field")
                    initializers.push(_);
                else
                    descriptor[key] = _;
            }
        }
        if (target)
            Object.defineProperty(target, contextIn.name, descriptor);
        done = true;
    }
    ;
    function __runInitializers(thisArg, initializers, value) {
        var useValue = arguments.length > 2;
        for (var i = 0; i < initializers.length; i++) {
            value = useValue ? initializers[i].call(thisArg, value) : initializers[i].call(thisArg);
        }
        return useValue ? value : void 0;
    }
    ;
    function __propKey(x) {
        return typeof x === "symbol" ? x : "".concat(x);
    }
    ;
    function __setFunctionName(f, name, prefix) {
        if (typeof name === "symbol")
            name = name.description ? "[".concat(name.description, "]") : "";
        return Object.defineProperty(f, "name", { configurable: true, value: prefix ? "".concat(prefix, " ", name) : name });
    }
    ;
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (g && (g = 0, op[0] && (_ = 0)), _)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        var desc = Object.getOwnPropertyDescriptor(m, k);
        if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
            desc = { enumerable: true, get: function () { return m[k]; } };
        }
        Object.defineProperty(o, k2, desc);
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from, pack) {
        if (pack || arguments.length === 2)
            for (var i = 0, l = from.length, ar; i < l; i++) {
                if (ar || !(i in from)) {
                    if (!ar)
                        ar = Array.prototype.slice.call(from, 0, i);
                    ar[i] = from[i];
                }
            }
        return to.concat(ar || Array.prototype.slice.call(from));
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: false } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, state, kind, f) {
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a getter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot read private member from an object whose class did not declare it");
        return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
    }
    function __classPrivateFieldSet(receiver, state, value, kind, f) {
        if (kind === "m")
            throw new TypeError("Private method is not writable");
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a setter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot write private member to an object whose class did not declare it");
        return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
    }
    function __classPrivateFieldIn(state, receiver) {
        if (receiver === null || (typeof receiver !== "object" && typeof receiver !== "function"))
            throw new TypeError("Cannot use 'in' operator on non-object");
        return typeof state === "function" ? receiver === state : state.has(receiver);
    }

    var filterNil = function (source) { return source.pipe(operators.filter(function (value) { return value !== null && typeof value !== 'undefined'; })); };
    function coerceArray(value) {
        if (isNil(value)) {
            return [];
        }
        return Array.isArray(value) ? value : [value];
    }
    function isNil(v) {
        return v === null || v === undefined;
    }
    function clone(value) {
        return isObject(value) ? Object.assign({}, value) : Array.isArray(value) ? __spreadArray([], __read(value)) : value;
    }
    function isValidDate(value) {
        return value && Object.prototype.toString.call(value) === '[object Date]' && !isNaN(value);
    }
    function isObject(val) {
        if (val == null || Array.isArray(val) || isValidDate(val)) {
            return false;
        }
        return typeof val === 'object';
    }
    var removeKeys = [
        'dirty',
        'disabled',
        'invalid',
        'pending',
        'errors',
        'pristine',
        'touched',
        'valid',
    ];
    function filterControlKeys(value) {
        return filterKeys(value, function (key) { return removeKeys.includes(key); });
    }
    function filtrArrayKeys(arr, cb) {
        return arr.reduce(function (acc, control, index) {
            acc[index] = filterKeys(control, cb);
            return acc;
        }, []);
    }
    function filterKeys(obj, cb) {
        var e_1, _a;
        var filtered = {};
        try {
            for (var _b = __values(Object.keys(obj)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var key = _c.value;
                var value = obj[key];
                if (cb(key) === false) {
                    if (isObject(value)) {
                        filtered[key] = filterKeys(value, cb);
                    }
                    else if (Array.isArray(value) && key === 'controls') {
                        filtered[key] = filtrArrayKeys(value, cb);
                    }
                    else {
                        filtered[key] = value;
                    }
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return filtered;
    }
    function isBrowser() {
        return typeof window !== 'undefined';
    }
    function mergeDeep(target) {
        var _a, _b;
        var sources = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            sources[_i - 1] = arguments[_i];
        }
        if (!sources.length) {
            return target;
        }
        var source = sources.shift();
        if (isObject(target) && isObject(source)) {
            for (var key in source) {
                if (isObject(source[key])) {
                    if (!target[key]) {
                        Object.assign(target, (_a = {}, _a[key] = {}, _a));
                    }
                    mergeDeep(target[key], source[key]);
                }
                else {
                    Object.assign(target, (_b = {}, _b[key] = source[key], _b));
                }
            }
        }
        return mergeDeep.apply(void 0, __spreadArray([target], __read(sources)));
    }

    function toStore(name, control) {
        var e_1, _a;
        var value;
        if (control instanceof forms.FormControl) {
            value = buildValue(control);
            return value;
        }
        if (control instanceof forms.FormGroup || control instanceof forms.FormArray) {
            value = buildValue(control);
            try {
                for (var _b = __values(Object.keys(control.controls)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var key = _c.value;
                    var current = control.controls[key];
                    if (current instanceof forms.FormGroup || current instanceof forms.FormArray) {
                        value.controls[key] = toStore(name, current);
                    }
                    else {
                        value.controls[key] = buildValue(current);
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_1) throw e_1.error; }
            }
        }
        return value;
    }
    function handleFormArray(formValue, control, arrControlFactory) {
        if (control instanceof forms.FormArray) {
            clearFormArray(control);
            if (!arrControlFactory) {
                throw new Error('Please provide arrControlFactory');
            }
            formValue.forEach(function (v, i) { return control.insert(i, arrControlFactory(v)); });
        }
        else {
            Object.keys(formValue).forEach(function (controlName) {
                var value = formValue[controlName];
                if (Array.isArray(value) && control.get(controlName) instanceof forms.FormArray) {
                    if (!arrControlFactory || (arrControlFactory && !(controlName in arrControlFactory))) {
                        throw new Error("Please provide arrControlFactory for " + controlName);
                    }
                    var current_1 = control.get(controlName);
                    var fc_1 = arrControlFactory[controlName];
                    clearFormArray(current_1);
                    value.forEach(function (v, i) { return current_1.insert(i, fc_1(v)); });
                }
            });
        }
    }
    function deleteControl(snapshot, controls) {
        return Object.keys(snapshot).reduce(function (acc, currentFormName) {
            if (controls.includes(currentFormName) === false) {
                acc[currentFormName] = snapshot[currentFormName];
            }
            return acc;
        }, {});
    }
    function findControl(control, path) {
        var _a = __read(path.split('.')), first = _a[0], rest = _a.slice(1);
        if (rest.length === 0) {
            return control.controls[first];
        }
        return rest.reduce(function (current, name) {
            return current.controls.hasOwnProperty(name) ? current.controls[name] : null;
        }, control.controls[first]);
    }
    function buildValue(control) {
        var value = {
            value: clone(control.value),
            rawValue: control.getRawValue ? control.getRawValue() : null,
            valid: control.valid,
            dirty: control.dirty,
            invalid: control.invalid,
            disabled: control.disabled,
            errors: control.errors,
            touched: control.touched,
            pristine: control.pristine,
            pending: control.pending,
            untouched: control.untouched,
        };
        if (control instanceof forms.FormGroup || control instanceof forms.FormArray) {
            value['controls'] = control instanceof forms.FormArray ? [] : {};
        }
        return value;
    }
    function clearFormArray(control) {
        while (control.length !== 0) {
            control.removeAt(0);
        }
    }

    var defaults = {
        storage: {
            key: 'ngFormsManager',
        },
        debounceTime: 300,
    };
    function mergeConfig(defaults, providerConfig, inlineConfig) {
        if (providerConfig === void 0) { providerConfig = {}; }
        return Object.assign(Object.assign(Object.assign(Object.assign({}, defaults), providerConfig), inlineConfig), { storage: Object.assign(Object.assign(Object.assign({}, defaults.storage), providerConfig.storage), inlineConfig.storage) });
    }
    var NgFormsManagerConfig = /** @class */ (function () {
        function NgFormsManagerConfig(config) {
            if (config === void 0) { config = {}; }
            this.config = config;
        }
        NgFormsManagerConfig.prototype.merge = function (inline) {
            if (inline === void 0) { inline = {}; }
            return mergeConfig(defaults, this.config, inline);
        };
        return NgFormsManagerConfig;
    }());
    var NG_FORMS_MANAGER_CONFIG = new i0.InjectionToken('NG_FORMS_MANAGER_CONFIG', {
        providedIn: 'root',
        factory: function () {
            return new NgFormsManagerConfig();
        },
    });

    var FormsStore = /** @class */ (function () {
        function FormsStore(state) {
            this.state = state;
            this.store = new rxjs.BehaviorSubject(state);
        }
        FormsStore.prototype.select = function (project) {
            return this.store.asObservable().pipe(operators.map(project), operators.distinctUntilChanged());
        };
        FormsStore.prototype.getValue = function () {
            return this.store.getValue();
        };
        FormsStore.prototype.set = function (state) {
            this.store.next(state);
        };
        FormsStore.prototype.update = function (state) {
            this.store.next(Object.assign({}, this.getValue(), state));
        };
        return FormsStore;
    }());

    // https://github.com/epoberezkin/fast-deep-equal
    function isEqual(a, b) {
        if (a === b) {
            return true;
        }
        if (a && b && typeof a == 'object' && typeof b == 'object') {
            if (a.constructor !== b.constructor) {
                return false;
            }
            var length, i, keys;
            if (Array.isArray(a)) {
                length = a.length;
                if (length != b.length) {
                    return false;
                }
                for (i = length; i-- !== 0;) {
                    if (!isEqual(a[i], b[i])) {
                        return false;
                    }
                }
                return true;
            }
            if (a.constructor === RegExp) {
                return a.source === b.source && a.flags === b.flags;
            }
            if (a.valueOf !== Object.prototype.valueOf) {
                return a.valueOf() === b.valueOf();
            }
            if (a.toString !== Object.prototype.toString) {
                return a.toString() === b.toString();
            }
            keys = Object.keys(a);
            length = keys.length;
            if (length !== Object.keys(b).length) {
                return false;
            }
            for (i = length; i-- !== 0;) {
                if (!Object.prototype.hasOwnProperty.call(b, keys[i])) {
                    return false;
                }
            }
            for (i = length; i-- !== 0;) {
                var key = keys[i];
                if (!isEqual(a[key], b[key])) {
                    return false;
                }
            }
            return true;
        }
        // true if both NaN, false otherwise
        return a !== a && b !== b;
    }

    /**
     * Injection Token to safely inject
     * {@link https://developer.mozilla.org/en-US/docs/Web/API/Window/sessionStorage} to Angular DI
     */
    var SESSION_STORAGE_TOKEN = new i0.InjectionToken('SESSION_STORAGE_TOKEN', {
        providedIn: 'root',
        factory: function () { return (common.isPlatformBrowser(i0.inject(i0.PLATFORM_ID)) ? sessionStorage : undefined); },
    });
    /**
     * Injection Token to safely inject
     * {@link https://developer.mozilla.org/en-US/docs/Web/API/Window/localStorage} to Angular DI
     */
    var LOCAL_STORAGE_TOKEN = new i0.InjectionToken('LOCAL_STORAGE_TOKEN', {
        providedIn: 'root',
        factory: function () { return (common.isPlatformBrowser(i0.inject(i0.PLATFORM_ID)) ? localStorage : undefined); },
    });
    /**
     * Injection Token to inject custom storage approach for persistence; must implement
     * {@link https://developer.mozilla.org/en-US/docs/Web/API/Storage} interface
     */
    var FORMS_MANAGER_STORAGE = new i0.InjectionToken('FORMS_MANAGER_STORAGE', {
        providedIn: 'root',
        factory: function () { return common.isPlatformBrowser(i0.inject(i0.PLATFORM_ID)) ? i0.inject(LOCAL_STORAGE_TOKEN) : undefined; },
    });
    /**
     * Value provider that injects usage of
     * {@link https://developer.mozilla.org/en-US/docs/Web/API/Window/sessionStorage} for persistence
     */
    var FORMS_MANAGER_SESSION_STORAGE_PROVIDER = {
        provide: FORMS_MANAGER_STORAGE,
        useExisting: SESSION_STORAGE_TOKEN,
    };

    var NO_DEBOUNCE = Symbol('NO_DEBOUNCE');
    // @dynamic; see https://angular.io/guide/angular-compiler-options#strictmetadataemit
    var NgFormsManager = /** @class */ (function () {
        function NgFormsManager(config, browserStorage) {
            this.config = config;
            this.browserStorage = browserStorage;
            this.valueChanges$$ = new Map();
            this.instances$$ = new Map();
            this.initialValues$$ = new Map();
            this.destroy$$ = new rxjs.Subject();
            this.store = new FormsStore({});
        }
        /**
         *
         * @example
         *
         * Whether the control is valid
         *
         * const valid$ = manager.validityChanges('login');
         *
         */
        NgFormsManager.prototype.validityChanges = function (name, path) {
            return this.controlChanges(name, path).pipe(operators.map(function (control) { return control.valid; }));
        };
        /**
         *
         * Whether the control is valid
         *
         * @example
         *
         * manager.isValid(name);
         *
         */
        NgFormsManager.prototype.isValid = function (name) {
            return this.hasControl(name) && this.getControl(name).valid;
        };
        /**
         *
         * @example
         *
         * Whether the control is dirty
         *
         * const dirty$ = manager.dirtyChanges('login');
         *
         */
        NgFormsManager.prototype.dirtyChanges = function (name, path) {
            return this.controlChanges(name, path).pipe(operators.map(function (control) { return control.dirty; }));
        };
        /**
         *
         * @example
         *
         * Whether the control is disabled
         *
         * const disabled$ = manager.disableChanges('login');
         *
         */
        NgFormsManager.prototype.disableChanges = function (name, path) {
            return this.controlChanges(name, path).pipe(operators.map(function (control) { return control.disabled; }));
        };
        NgFormsManager.prototype.valueChanges = function (name, path) {
            return this.controlChanges(name, path).pipe(operators.map(function (control) { return control.value; }));
        };
        /**
         *
         * @example
         *
         * Observe the control's errors
         *
         * const errors$ = manager.errorsChanges<Errors>('login');
         * const errors$ = manager.errorsChanges<Errors>('login', 'email');
         *
         */
        NgFormsManager.prototype.errorsChanges = function (name, path) {
            return this.controlChanges(name, path).pipe(operators.map(function (control) { return control.errors; }));
        };
        NgFormsManager.prototype.controlChanges = function (name, path) {
            var control$ = this.store.select(function (state) { return state[name]; }).pipe(filterNil);
            if (!path) {
                return control$.pipe(operators.distinctUntilChanged(function (a, b) { return isEqual(a, b); }));
            }
            return control$.pipe(operators.map(function (control) { return findControl(control, path); }), operators.distinctUntilChanged(function (a, b) { return isEqual(a, b); }));
        };
        /**
         *
         * Whether the initial control value is deep equal to current value
         *
         * @example
         *
         * const dirty$ = manager.initialValueChanged('settings');
         *
         */
        NgFormsManager.prototype.initialValueChanged = function (name) {
            var _this = this;
            if (this.initialValues$$.has(name) === false) {
                console.error("You should set the withInitialValue option to the " + name + " control");
            }
            return this.valueChanges(name).pipe(operators.map(function (current) { return isEqual(current, _this.initialValues$$.get(name)) === false; }));
        };
        /**
         *
         * @example
         *
         * Emits when the control is destroyed
         *
         * const control$ = manager.controlChanges('login').pipe(takeUntil(controlDestroyed('login')))
         *
         */
        NgFormsManager.prototype.controlDestroyed = function (name) {
            return this.destroy$$
                .asObservable()
                .pipe(operators.filter(function (controlName) { return name === controlName || controlName === '$$ALL'; }));
        };
        NgFormsManager.prototype.getControl = function (name, path) {
            if (!path) {
                return this.store.getValue()[name];
            }
            if (this.hasControl(name)) {
                var control = this.getControl(name);
                return findControl(control, path);
            }
            return null;
        };
        NgFormsManager.prototype.getInitialValue = function (name) {
            return this.initialValues$$.get(name);
        };
        /**
         *
         * @example
         *
         *  Whether the form exists
         *
         * manager.hasControl('login');
         * manager.hasControl('login', 'email');
         *
         */
        NgFormsManager.prototype.hasControl = function (name, path) {
            return !!this.getControl(name, path);
        };
        /**
         *
         * @example
         *
         * A proxy to the original `patchValue` method
         *
         * manager.patchValue('login', { email: '' });
         *
         */
        NgFormsManager.prototype.patchValue = function (name, value, options) {
            if (this.instances$$.has(name)) {
                this.instances$$.get(name).patchValue(value, options);
            }
        };
        /**
         *
         * @example
         *
         * A proxy to the original `setValue` method
         *
         * manager.setValue('login', { email: '', name: '' });
         *
         */
        NgFormsManager.prototype.setValue = function (name, value, options) {
            if (this.instances$$.has(name)) {
                this.instances$$.get(name).setValue(value, options);
            }
        };
        /**
         *
         * @example
         *
         * A proxy to the original `reset` method
         *
         * manager.reset('login', { email: '' });
         *
         */
        NgFormsManager.prototype.reset = function (name, value, options) {
            if (this.instances$$.has(name)) {
                this.instances$$.get(name).reset(value, options);
            }
        };
        /**
         *
         * Sets the initial value for a control
         *
         * @example
         *
         * manager.setInitialValue('login', value);
         *
         */
        NgFormsManager.prototype.setInitialValue = function (name, value) {
            this.initialValues$$.set(name, value);
        };
        /**
         *
         * @example
         *
         * A proxy to the original `markAllAsTouched` method
         *
         * manager.markAllAsTouched('login');
         *
         */
        NgFormsManager.prototype.markAllAsTouched = function (name) {
            if (this.instances$$.has(name)) {
                this.instances$$.get(name).markAllAsTouched();
                this.updateStore(name, this.instances$$.get(name));
            }
        };
        /**
         *
         * @example
         *
         * A proxy to the original `markAsTouched` method
         *
         * manager.markAsTouched('login');
         *
         */
        NgFormsManager.prototype.markAsTouched = function (name, options) {
            if (this.instances$$.has(name)) {
                this.instances$$.get(name).markAsTouched(options);
                this.updateStore(name, this.instances$$.get(name));
            }
        };
        /**
         *
         * @example
         *
         * Marks the control and all its descendant controls as dirty.
         *
         * manager.markAllAsDirty('login');
         *
         */
        NgFormsManager.prototype.markAllAsDirty = function (name, options) {
            if (this.instances$$.has(name)) {
                var control = this.instances$$.get(name);
                this.markDescendantsAsDirty(control, options);
                this.updateStore(name, control);
            }
        };
        /**
         *
         * @example
         *
         * A proxy to the original `markAsDirty` method
         *
         * manager.markAsDirty('login');
         *
         */
        NgFormsManager.prototype.markAsDirty = function (name, options) {
            if (this.instances$$.has(name)) {
                this.instances$$.get(name).markAsDirty(options);
                this.updateStore(name, this.instances$$.get(name));
            }
        };
        /**
         *
         * @example
         *
         * A proxy to the original `markAsPending` method
         *
         * manager.markAsPending('login');
         *
         */
        NgFormsManager.prototype.markAsPending = function (name, options) {
            if (this.instances$$.has(name)) {
                this.instances$$.get(name).markAsPending(options);
                this.updateStore(name, this.instances$$.get(name));
            }
        };
        /**
         *
         * @example
         *
         * A proxy to the original `markAsPristine` method
         *
         * manager.markAsPristine('login');
         *
         */
        NgFormsManager.prototype.markAsPristine = function (name, options) {
            if (this.instances$$.has(name)) {
                this.instances$$.get(name).markAsPristine(options);
                this.updateStore(name, this.instances$$.get(name));
            }
        };
        /**
         *
         * @example
         *
         * A proxy to the original `markAsUntouched` method
         *
         * manager.markAsUntouched('login');
         *
         */
        NgFormsManager.prototype.markAsUntouched = function (name, options) {
            if (this.instances$$.has(name)) {
                this.instances$$.get(name).markAsUntouched(options);
                this.updateStore(name, this.instances$$.get(name));
            }
        };
        /**
         *
         * @example
         *
         * manager.unsubscribe('login');
         *
         */
        NgFormsManager.prototype.unsubscribe = function (name) {
            var e_1, _b;
            var _this = this;
            if (name) {
                var names = coerceArray(name);
                try {
                    for (var names_1 = __values(names), names_1_1 = names_1.next(); !names_1_1.done; names_1_1 = names_1.next()) {
                        var name_1 = names_1_1.value;
                        if (this.valueChanges$$.has(name_1)) {
                            this.valueChanges$$.get(name_1).unsubscribe();
                        }
                        this.valueChanges$$.delete(name_1);
                        this.instances$$.delete(name_1);
                        this.destroy$$.next(name_1);
                    }
                }
                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                finally {
                    try {
                        if (names_1_1 && !names_1_1.done && (_b = names_1.return)) _b.call(names_1);
                    }
                    finally { if (e_1) throw e_1.error; }
                }
            }
            else {
                this.valueChanges$$.forEach(function (subscription) {
                    subscription.unsubscribe();
                    _this.destroy$$.next('$$ALL');
                });
                this.valueChanges$$.clear();
                this.instances$$.clear();
            }
        };
        /**
         *
         * @example
         *
         * Removes the control from the store and from browser storage
         *
         * manager.clear('login');
         *
         */
        NgFormsManager.prototype.clear = function (name) {
            name ? this.deleteControl(name) : this.store.set({});
            this.removeFromStorage();
            this.removeInitialValue(name);
        };
        /**
         *
         * @example
         *
         * Calls unsubscribe and clear
         *
         * manager.destroy('login');
         *
         */
        NgFormsManager.prototype.destroy = function (name) {
            this.unsubscribe(name);
            this.clear(name);
        };
        /**
         *
         * @example
         *
         * Register a control
         *
         * manager.upsert('login', this.login);
         * manager.upsert('login', this.login, { persistState: true });
         * manager.upsert('login', this.login, { debounceTime: 500 });
         *
         * manager.upsert('login', this.login, { arrControlFactory: value => new FormControl('') });
         *
         */
        NgFormsManager.prototype.upsert = function (name, control, config) {
            var _b;
            var _this = this;
            if (config === void 0) { config = {}; }
            var mergedConfig = this.config.merge(config);
            if (mergedConfig.withInitialValue && this.initialValues$$.has(name) === false) {
                this.setInitialValue(name, control.value);
            }
            if (isBrowser() && config.persistState && this.hasControl(name) === false) {
                var storageValue = this.getFromStorage(mergedConfig.storage.key);
                if (storageValue[name]) {
                    this.store.update((_b = {},
                        _b[name] = mergeDeep(toStore(name, control), storageValue[name]),
                        _b));
                }
            }
            /** If the control already exist, patch the control with the store value */
            if (this.hasControl(name) === true) {
                control.patchValue(this.toControlValue(name, control, mergedConfig.arrControlFactory), {
                    emitEvent: false,
                });
            }
            else {
                var value = this.updateStore(name, control);
                this.updateStorage(name, value, mergedConfig);
            }
            var unsubscribe = rxjs.merge.apply(void 0, __spreadArray([control.statusChanges.pipe(operators.distinctUntilChanged())], __read(this.getValueChangeStreams(control)))).pipe(operators.debounce(function (value) { return (value === NO_DEBOUNCE ? rxjs.EMPTY : rxjs.timer(mergedConfig.debounceTime)); }))
                .subscribe(function () {
                var value = _this.updateStore(name, control);
                _this.updateStorage(name, value, mergedConfig);
            });
            this.valueChanges$$.set(name, unsubscribe);
            this.instances$$.set(name, control);
            return this;
        };
        NgFormsManager.prototype.getValueChangeStreams = function (control) {
            var streams = [];
            if (control.updateOn === 'blur') {
                streams.push(control.valueChanges.pipe(operators.mapTo(NO_DEBOUNCE)));
            }
            else {
                streams.push(control.valueChanges);
                if (control instanceof forms.FormGroup) {
                    return Object.keys(control.controls).reduce(function (previous, key) { return control.get(key).updateOn === 'blur'
                        ? __spreadArray(__spreadArray([], __read(previous)), [control.get(key).valueChanges.pipe(operators.mapTo(NO_DEBOUNCE))]) : __spreadArray([], __read(previous)); }, streams);
                }
            }
            return streams;
        };
        NgFormsManager.prototype.removeFromStorage = function () {
            var _a;
            (_a = this.browserStorage) === null || _a === void 0 ? void 0 : _a.setItem(this.config.merge().storage.key, JSON.stringify(this.store.getValue()));
        };
        NgFormsManager.prototype.updateStorage = function (name, value, config) {
            var _a;
            if (isBrowser() && config.persistState) {
                var storageValue = this.getFromStorage(config.storage.key);
                storageValue[name] = filterControlKeys(value);
                (_a = this.browserStorage) === null || _a === void 0 ? void 0 : _a.setItem(config.storage.key, JSON.stringify(storageValue));
            }
        };
        NgFormsManager.prototype.getFromStorage = function (key) {
            var _a;
            return JSON.parse(((_a = this.browserStorage) === null || _a === void 0 ? void 0 : _a.getItem(key)) || '{}');
        };
        NgFormsManager.prototype.deleteControl = function (name) {
            this.store.set(deleteControl(this.store.getValue(), coerceArray(name)));
        };
        NgFormsManager.prototype.toControlValue = function (name, control, arrControlFactory) {
            var currentControl = this.getControl(name);
            var value = currentControl.value;
            /** It means it's not a FormGroup or FormArray */
            if (!currentControl.controls) {
                return value;
            }
            handleFormArray(value, control, arrControlFactory);
            return value;
        };
        NgFormsManager.prototype.updateStore = function (name, control) {
            var _b;
            var value = toStore(name, control);
            this.store.update((_b = {},
                _b[name] = value,
                _b));
            return value;
        };
        NgFormsManager.prototype.removeInitialValue = function (name) {
            var _this = this;
            name
                ? coerceArray(name).forEach(function (name) { return _this.initialValues$$.delete(name); })
                : this.initialValues$$.clear();
        };
        NgFormsManager.prototype.markDescendantsAsDirty = function (control, options) {
            var _this = this;
            control.markAsDirty(options);
            if (control instanceof forms.FormGroup || control instanceof forms.FormArray) {
                var controls = Object.keys(control.controls).map(function (controlName) { return control.controls[controlName]; });
                controls.forEach(function (control) {
                    control.markAsDirty(options);
                    if (control.controls) {
                        _this.markDescendantsAsDirty(control, options);
                    }
                });
            }
        };
        return NgFormsManager;
    }());
    /** @nocollapse */ NgFormsManager.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: NgFormsManager, deps: [{ token: NG_FORMS_MANAGER_CONFIG, optional: true }, { token: FORMS_MANAGER_STORAGE }], target: i0__namespace.ɵɵFactoryTarget.Injectable });
    /** @nocollapse */ NgFormsManager.ɵprov = i0__namespace.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: NgFormsManager, providedIn: 'root' });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: NgFormsManager, decorators: [{
                type: i0.Injectable,
                args: [{ providedIn: 'root' }]
            }], ctorParameters: function () {
            return [{ type: NgFormsManagerConfig, decorators: [{
                            type: i0.Optional
                        }, {
                            type: i0.Inject,
                            args: [NG_FORMS_MANAGER_CONFIG]
                        }] }, { type: Storage, decorators: [{
                            type: i0.Inject,
                            args: [FORMS_MANAGER_STORAGE]
                        }] }];
        } });

    function setValidators(control, validator) {
        control.setValidators(coerceArray(validator));
        control.updateValueAndValidity();
    }
    function setAsyncValidators(control, validator) {
        control.setValidators(coerceArray(validator));
        control.updateValueAndValidity();
    }

    /**
     * Generated bundle index. Do not edit.
     */

    exports.FORMS_MANAGER_SESSION_STORAGE_PROVIDER = FORMS_MANAGER_SESSION_STORAGE_PROVIDER;
    exports.FORMS_MANAGER_STORAGE = FORMS_MANAGER_STORAGE;
    exports.NG_FORMS_MANAGER_CONFIG = NG_FORMS_MANAGER_CONFIG;
    exports.NgFormsManager = NgFormsManager;
    exports.NgFormsManagerConfig = NgFormsManagerConfig;
    exports.setAsyncValidators = setAsyncValidators;
    exports.setValidators = setValidators;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ngneat-forms-manager.umd.js.map
