import { InjectionToken } from '@angular/core';
export declare type Config = {
    storage: {
        key: string;
    };
    debounceTime: number;
};
export declare function mergeConfig(defaults: Config, providerConfig: Partial<Config>, inlineConfig: Partial<Config>): Config;
export declare class NgFormsManagerConfig {
    private config;
    constructor(config?: Partial<Config>);
    merge(inline?: Partial<Config>): Config;
}
export declare const NG_FORMS_MANAGER_CONFIG: InjectionToken<NgFormsManagerConfig>;
