import { Observable } from 'rxjs';
export declare class FormsStore<S> {
    private state;
    private store;
    constructor(state: S);
    select<R>(project: (store: S) => R): Observable<R>;
    getValue(): S;
    set(state: S): void;
    update(state: Partial<S>): void;
}
